<?php
//TITLE=QuickBasic compiler clone (incomplete)

$title = 'QuickBasic compiler clone';
$progname = 'qbc';

function usagetext($prog)
{
  exec($prog.' --help', $kk);
  $k='';foreach($kk as $s)$k.="$s\n";
  return $k;
}

$text = array(
   '1. Purpose' => "

<b>This is a DEVELOPMENT PROJECT. It is NOT A FINISHED PRODUCT.</b>
 <p>
Purpose is to provide tools for running QuickBASIC programs in
Linux and other non-MS-DOS -environments.
 <p>
It currently seems like it will become a QuickBASIC to C++
translator. In fact, it already translates a large subset
of QuickBASIC to C++. However, the resulting code is not
maintainable, and the library which it requires, is not
finished. But it is being developed, in hopes it will
one day enable running complicated DOS-specific QuickBASIC programs
such as <a href=\"http://bisqwit.iki.fi/src/nesmpaku.bas\">this</a>,
under Linux.

<!--
Several ideas are, what this should become.
<ul>
 <li>Interpreter<blockquote>
        Pros:
        <ul>
         <li>Portable</li>
        </ul>
        Cons:
        <ul>
         <li>No standalone programs</li>
        </ul>
  </blockquote></li>
 <li>Compiler / translator, for:
     <ul>
      <li>Assembler<blockquote>
           Pros:
            <ul>
             <li>Should be fast</li>
            </ul>
           Cons:
            <ul>
             <li>Restricted to a certain architecture</li>
            </ul>
       </blockquote></li>
      <li>To C++ (CURRENT CHOICE)<blockquote>
           Pros:
            <ul>
             <li>Should become fast</li>
             <li>Multi-architecture</li>
            </ul>
           Cons:
            <ul>
             <li>Most certainly unmaintainable</li>
             <li>Requires a C++ compiler</li>
            </ul>
       </blockquote></li>
      <li>To Ruby<blockquote>
           Pros:
            <ul>
             <li>Should be elegant and maintainable</li>
             <li>Multi-architecture</li>
            </ul>
           Cons:
            <ul>
             <li>Ruby isn't yet very well-spread</li>
             <li>Certainly not so fast</li>
            </ul>
       </blockquote></li>
     </ul>
  </li>
</ul>
-->

", '1.1. Project status' => "

<ul>
 <li>Compiler is almost finished.</li>
 <li>Runtime library implementation has been started.</li>
</ul>

", '1.1. Features not omitted' => "

These features are often missing from other BASIC implementations,
because they are difficult to implement or not seemed as important.

<ul>
 <li><code>ON n GOTO</code>/<code>GOSUB</code></li>
 <li><code>READ</code>/<code>DATA</code>/<code>RESTORE</code></li>
 <li>Fully compatible <code>INKEY\$</code></li>
 <li><code>TIMER</code> function</li>
 <li>Type compatibility (<code>INTEGER</code> must still be 16-bit signed integer etc)</li>
 <li><code>PLAY</code>/<code>ON PLAY</code></li>
 <li><code>DEF FN</code></li>
 <li>Number printing and stringifying (<code>PRINT</code>, <code>STR\$</code>) compatibility (spaces!)</li>
 <li><code>OPEN</code>: Both syntaxes</li>
 <li><code>NEXT</code> with comma separated list of variables</li>
 <li><code>IF</code>: Both syntaxes plus implicit <code>GOTO</code> in <code>THEN</code> and <code>ELSE</code> support.</li>
 <li><code>PRINT</code> abbreviated as <code>?</code> support</li>
 <li>String constant shortcut syntax (from GW-BASIC): closing \" is not required, newline terminates</li>
 <li><code>PRINT</code> syntax shortcut (from GW-BASIC): parameters do not need to be separated by ;</li>
</ul>

", '1.1. Features supported if possible' => "

Some of these features require emulation of
PC-style hardware without direct hardware access.

<ul>
 <li><code>DEF SEG &amp;HB800</code>/<code>PEEK</code>/<code>POKE</code> support for direct video access in text mode</li>
 <li><code>IN</code>/<code>OUT</code> support to ports &amp;H388 - &amp;H389 for AdLib support</li>
 <li><code>SCREEN</code> 12/13, <code>PSET</code> and other drawing stuff</li>
</ul>

", '1.1. Features not considered to be supported' => "

These QuickBASIC features are not seen as important, and
will not be supported (unless somebody has too much time).

<ul>
 <li>All the excessive <code>ERR</code> codes like \"String formula too complex\" etc</li>
 <li><code>KEY ON</code>/<code>KEY OFF</code>  (dunno about <code>ON KEY</code>)</li>
 <li><code>FIELD</code> and other obscure file features (some of which were new in QB 7.0)</li>
 <li><code>COMMON</code>, <code>CHAIN</code></li>
</ul>

", '1.1. Features which are gained for free' => "

", '1.1.1. Memory allocation' => "

In modern operating systems, the memory allocation is designed so
that the user doesn't have to care about it. We don't have to meddle
with EMS/XMS or any other kind of perverse system the hardware requires
for memory allocation.<br>
So if you want to say <code>DIM area(1048576) AS INTEGER</code>,
it's fine!<br>
Things like <code>VARPTR\$</code> and <code>SADD()</code>
will have to be adjusted a bit though.

", '1.1.1. Hardware services' => "

In *nix systems, all the devices have been designed so that you
can use them by just opening the appropriate file from <code>/dev</code>
directory. For example, if you wanted to record and play with your soundcard,
you could do <code>OPEN \"/dev/dsp\" FOR BINARY AS #1</code>,
and that's fine. You read there (record), you write there (play).<br>
Of course this won't work in Windows systems.<br>
Other examples could be floppy disks, frame buffer consoles etc.<br>
<small>This isn't the whole truth. Some devices require you to do
 ioctls before you can do anything useful. This will be considered.</small>

", '1.1. Extra features' => "

There are no plans for extra features yet, but internationalizations
like UTF-8 support would be nice.

", '1.1.1. Multitasking' => "

QuickBasic programs are usually designed to take 100% of the CPU time
all the time. This badly fits to multitasking environments we nowadays
have in modern operating systems.<br>
But history is history, and we have to support it.<br>
But we don't have to limit ourselves to it. Even if we couldn't
detect and convert <code>Ti#=TIMER:WHILE TIMER&lt;Ti#+1:WEND</code>
style loops to <code>USLEEP 1000000</code>, we could support things
like <code>USLEEP</code> and <code>FORK</code>. Just maybe.<br>
See your favourite POSIX manual if you don't know what those functions
mean.
 <p>
The <code>ON&nbsp;PLAY(n)</code> mechanism
(and <code>ON&nbsp;KEY(n)</code>,
and <code>ON&nbsp;TIMER(n)</code>,
and <code>ON&nbsp;STRIG(n)</code>,
and <code>ON&nbsp;PEN</code>,
and <code>ON&nbsp;COM(n)</code>) could also be
implemented as threads.
That way, we wouldn't need to prefix each statement with a
call to a checking routine as is done by QuicBASIC. (We still
need to do that for <code>ON&nbsp;ERROR</code>, though,
because of <code>RESUME</code> which may require repeating
the same statement.)

", '1. Copying' => "

qbc has been written by Joel Yliluoma, a.k.a.
<a href=\"http://iki.fi/bisqwit/\">Bisqwit</a>,<br>
and is distributed under the terms of the
<a href=\"http://www.gnu.org/licenses/licenses.html#GPL\">General Public License</a> (GPL).
 <p>
If you utilize qbc or parts of it for any purpose, the author
wishes to hear of it (and possibly participate), but it is not
mandatory for using this software.

", '1.1. Documentation' => "

Extensive documentation of the design of this compiler
can be found in the source package in the doc/ directory.

", '1. Requirements' => "

At least these GNU tools are required: flex, gcc, make.<br>
It also utilizes <a href=\"http://home.clara.net/raoulgough/clamp/index.html\"
>clamp</a> (C++ lambda preprocessor), but it is included in the archive.<br>
boost::regex and boost::smart_ptr are also required.

", '1. "I want to start programming"' => "

Then learn programming. It's a slow journey which
requires patience and eagerness to learn new things.
 <p>
If you want to start programming with BASIC,
go and see <a href=\"http://www.darkbasic.com/\">DarkBasic</a>.

");
include '/WWW/progdesc.php';
