#include "bstringfun.hh"
#include "basfun.hh"
#include "error.hh"

#include <sstream>

const BAS_STR B_FuncSTRING_S(long n, const BAS_STR& s)
{
    if(s.empty()) B_ERROR(5); // illegal function call
    return BAS_STR(n, s[0]);
}

const BAS_STR B_FuncSTRING_S(long n, int i)
{
    if(i < 0 || i > 255) B_ERROR(5); // illegal function call
    return BAS_STR(n, (char) i);
}

const BAS_STR B_FuncSPACE_S(long n)
{
    return BAS_STR(n, ' ');
}

const BAS_STR B_FuncCHR_S(long n)
{
    if(n < 0 || n > 255) B_ERROR(5); // illegal function call
    char c = n;
    return std::string(&c, &c+1);
}

const BAS_STR B_FuncSTR_S(BAS_DBL d)       { return BasSTRs(d); }
const BAS_STR B_FuncSTR_S(long long int i)
{
    std::stringstream s;
    s << ' ' << i; return s.str();
}

const BAS_STR B_FuncHEX_S(BAS_LNG i)
{
    std::stringstream s;
    s << std::hex << i;
    return s.str();
}

const BAS_STR B_FuncHEX_S(long long i)
{
    std::stringstream s;
    s << std::hex << i;
    return s.str();
}

const BAS_STR B_FuncHEX_S(BAS_DBL d)
{
    return B_FuncHEX_S(BasCLNG(d));
}

BAS_INT B_FuncASC(const BAS_STR& s)
{
    if(s.empty()) B_ERROR(5); // illegal function call
    return s[0];
}
