#include <qblib/stream.hh>

class InputImplement: public InputStreamBase
{
protected:
    bool InputError;
public:
    virtual void InputTo(BAS_INT& target)
    {
        IgnoreBlankInput();
        long l = InputLong();
        target = l;
        if(l < -32768 || l > 32767) GotOverflow();
    }

    virtual void InputTo(BAS_SGN& target)
    {
        IgnoreBlankInput();
        target = InputLong();
    }

    virtual void InputTo(BAS_DBL& target)
    {
        IgnoreBlankInput();
        target = InputLong();
    }

    virtual void InputTo(BAS_LNG& target)
    {
        IgnoreBlankInput();
        target = InputLong();
    }

    virtual void InputTo(BAS_STR& target)
    {
        // anything until comma or eol or eof
        // ignore spaces at beginning and end
        // if quote encountered while string empty, parse until quote or eol or eof.
        //    After quote, ignore spaces.
        IgnoreBlankInput();
    }
    
protected:
    virtual int InputChar() = 0;
    virtual void GotOverflow() = 0;

    long double InputLong()
    {
        std::string tmp;
    }
    void IgnoreBlankInput()
    {
    }
};
